﻿/*
 * Copyright 2011 Arne Vajhøj.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. 
 */

using System;

namespace Vajhoej.StaticWeaver
{
    /// <summary>
    /// Attribute Aspect marks an aspect.
    /// </summary>
    public class AspectAttribute : Attribute
    {
    }
    /// <summary>
    /// Attribute Pointcut marks a pointcut.
    /// </summary>
    public class PointcutAttribute : Attribute
    {
        /// <summary>
        /// Signature of pointcut.
        /// </summary>
        public string Signature { get; set; }
    }
    /// <summary>
    /// Attribute BeforeCall marks a before call advice.
    /// </summary>
    public class BeforeCallAdviceAttribute : Attribute
    {
        /// <summary>
        /// Pointcut to apply advice to.
        /// </summary>
        public string Pointcut { get; set; }
    }
    /// <summary>
    /// Attribute AfterCall marks a after call advice.
    /// </summary>
    public class AfterCallAdviceAttribute : Attribute
    {
        /// <summary>
        /// Pointcut to apply advice to.
        /// </summary>
        public string Pointcut { get; set; }
    }
}
